routes/web.php
<?php

Auth::routes();

//Route::get('/test', 'TestController@index')->name('test');
Route::get('/privacy-policy', 'HomeController@privacy_policy')->name('privacy_policy');
Route::get('/terms-of-use', 'HomeController@terms_of_use')->name('terms_of_use');


Route::group(['middleware' => 'auth'], function () {

    Route::get('/', 'HomeController@dashboard')->name('home');
    Route::get('/home', 'HomeController@dashboard')->name('home');
    Route::get('/dashboard', 'HomeController@dashboard')->name('dashboard');

    Route::group(['prefix' => 'my_account'], function() {
        Route::get('/', 'MyAccountController@edit_profile')->name('my_account');
        Route::put('/', 'MyAccountController@update_profile')->name('my_account.update');
        Route::put('/change_password', 'MyAccountController@change_pass')->name('my_account.change_pass');
    });

    /*************** Support Team *****************/
    Route::group(['namespace' => 'SupportTeam',], function(){

        /*************** Students *****************/
        Route::group(['prefix' => 'students'], function(){
            Route::get('reset_pass/{st_id}', 'StudentRecordController@reset_pass')->name('st.reset_pass');
            Route::get('graduated', 'StudentRecordController@graduated')->name('students.graduated');
            Route::put('not_graduated/{id}', 'StudentRecordController@not_graduated')->name('st.not_graduated');


            /* Promotions */
            Route::post('promote_selector', 'PromotionController@selector')->name('students.promote_selector');
            Route::get('promotion/manage', 'PromotionController@manage')->name('students.promotion_manage');
            Route::delete('promotion/reset/{pid}', 'PromotionController@reset')->name('students.promotion_reset');
            Route::delete('promotion/reset_all', 'PromotionController@reset_all')->name('students.promotion_reset_all');
            Route::get('promotion', 'PromotionController@promotion')->name('students.promotion');
            Route::post('promote/{fc}/{fs}/{tc}/{ts}', 'PromotionController@promote')->name('students.promote');

        });

        Route::get('promotion/getCurrentStudents', 'PromotionController@getCurrentStudents');
        Route::post('promotion/addPromotion', 'PromotionController@addPromotion');
        Route::get('promotion/getPromotedStudents', 'PromotionController@getPromotedStudents');

        /*************** Users *****************/
        Route::group(['prefix' => 'users'], function(){
            Route::get('reset_pass/{id}', 'UserController@reset_pass')->name('users.reset_pass');
        });

        /*************** Payments *****************/


        /*************** Pins *****************/


        /*************** Marks *****************/


        Route::resource('faculty', 'FacultyController');
        Route::resource('users', 'UserController');
        Route::resource('courses', 'MyCoursesController');
        Route::resource('sessions', 'SessionController');
        Route::resource('degree', 'DegreeController');
        Route::resource('department', 'DepartmentController');
        Route::resource('students', 'StudentRecordController');


        Route::resource('exams', 'ExamController');
        Route::resource('payments', 'PaymentController');

    });

    /************************ AJAX ****************************/
    Route::group(['prefix' => 'ajax'], function() {
        Route::get('get_lga/{state_id}', 'AjaxController@get_lga')->name('get_lga');
        Route::get('get_class_sections/{class_id}', 'AjaxController@get_class_sections')->name('get_class_sections');
        Route::get('get_class_subjects/{class_id}', 'AjaxController@get_class_subjects')->name('get_class_subjects');
    });

});

/************************ SUPER ADMIN ****************************/
Route::group(['namespace' => 'SuperAdmin','middleware' => 'super_admin', 'prefix' => 'super_admin'], function(){

    Route::get('/settings', 'SettingController@index')->name('settings');
    Route::put('/settings', 'SettingController@update')->name('settings.update');
    Route::get('/customfields', 'SettingController@customfields');
    Route::post('/storefield', 'SettingController@storefield');
    Route::post('/updatefield/{id}', 'SettingController@updatefield');

    Route::get('/editcustomefield/{id}', 'SettingController@editcustomefield');
    Route::delete('/destroycustomfield/{id}', 'SettingController@destroycustomfield');

});

/************************ PARENT ****************************/
Route::group(['namespace' => 'MyParent','middleware' => 'my_parent',], function(){

    Route::get('/my_children', 'MyController@children')->name('my_children');

});

app/Models/Department.php
<?php

namespace App\Models;

use Eloquent;

class Department extends Eloquent
{
    protected  $fillable = ['name'];
}

app/Http/Controllers/SupportTeam/DegreeController.php
<?php

namespace App\Http\Controllers\SupportTeam;

use Illuminate\Http\Request;
use App\Repositories\DegreeRepo;
use App\Http\Controllers\Controller;
use App\Helpers\Qs;

class DegreeController extends Controller
{
    protected $degree;

    public function __construct(DegreeRepo $degree )
    {
        $this->degree = $degree;

        $this->middleware('teamSA', ['except' => ['destroy',] ]);
        $this->middleware('super_admin', ['only' => ['destroy',] ]);
    }

    public function index()
    {
         $d['degree'] = $this->degree->all();

        return view('pages.support_team.degree.index', $d);
    }

    public function store(Request $req)
    {
        $data = $req->all();

        $this->degree->create($data);
        return Qs::jsonStoreOk();
    }

    public function edit($id)
    {

        $d['degree'] = $this->degree->find($id);
        return view('pages.support_team.degree.edit', $d);


    }

    public function update(Request $req, $id)
    {
        $data = $req->all();

        $this->degree->update($id, $data);
        return back()->with('flash_success', __('msg.update_ok'));
    }

    public function destroy($id)
    {
        $this->degree->deleteGrade($id);
        return back()->with('flash_success', __('msg.del_ok'));
    }
}

app/Http/Controllers/SupportTeam/DepartmentController.php
<?php

namespace App\Http\Controllers\SupportTeam;

use App\Helpers\Qs;
use Illuminate\Http\Request;

use App\Repositories\DepartmentRepo;
use App\Http\Controllers\Controller;

class DepartmentController extends Controller
{
    protected $department;

    public function __construct(DepartmentRepo $department)
    {
        $this->middleware('teamSA', ['except' => ['destroy',] ]);
        $this->middleware('super_admin', ['only' => ['destroy',] ]);

        $this->department = $department;

    }

    public function index()
    {
        $d['department'] = $this->department->all();

        return view('pages.support_team.department.index', $d);
    }

    public function store(Request $req)
    {
        $data = $req->all();
        $this->department->create($data);

        return Qs::jsonStoreOk();
    }

    public function edit($id)
    {
        $d['s'] = $sub  = $this->department->find($id);

        return !is_null($sub) ? view('pages.support_team.department.edit', $d)
            : Qs::goWithDanger('department.index');
//        $d['s'] = $sub = $this->department->find($id);
//
//
//        return is_null($sub) ? Qs::goWithDanger('department.index') : view('pages.support_team.department.edit', $d);
    }

    public function update(Request $req, $id)
    {
        $data = $req->all();
        $this->department->update($id, $data);

        return Qs::jsonUpdateOk();
    }

    public function destroy($id)
    {
        $this->department->delete($id);
        return back()->with('flash_success', __('msg.del_ok'));
    }
}

app/Http/Controllers/SupportTeam/FacultyController.php
<?php

namespace App\Http\Controllers\SupportTeam;
use Illuminate\Http\Request;
use App\Helpers\Qs;
use App\Http\Controllers\Controller;
use App\Repositories\FacultyRepo;

class FacultyController extends Controller
{
    protected $faculty;

    public function __construct(FacultyRepo $faculty)
    {
        $this->middleware('teamSA', ['except' => ['destroy',] ]);
        $this->middleware('super_admin', ['only' => ['destroy',] ]);

        $this->faculty = $faculty;
    }

    public function index()
    {
        $d['faculty'] = $this->faculty->getAll();
        return view('pages.support_team.faculty.index', $d);
    }

    public function store(Request $req)
    {
        $data = $req->only(['name', 'description']);
        $this->faculty->create($data);

        return Qs::jsonStoreOk();
    }

    public function edit($id)
    {
        $d['faculty'] = $faculty = $this->faculty->find($id);

        return !is_null($faculty) ? view('pages.support_team.faculty.edit', $d)
            : Qs::goWithDanger('facultys.index');
    }

    public function update(Request $req, $id)
    {
        $data = $req->only(['name', 'description']);
        $this->faculty->update($id, $data);

        return Qs::jsonUpdateOk();
    }

    public function destroy($id)
    {
        $this->faculty->find($id)->delete();
        return back()->with('flash_success', __('msg.delete_ok'));
    }
}

app/Http/Controllers/SupportTeam/MyCoursesController.php
<?php

namespace App\Http\Controllers\SupportTeam;
use Illuminate\Http\Request;
use App\Helpers\Qs;

use App\Repositories\MyCourseRepo;
use App\Repositories\UserRepo;
use App\Http\Controllers\Controller;

class MyCoursesController extends Controller
{
    protected $my_course, $user;

    public function __construct(MyCourseRepo $my_course, UserRepo $user)
    {
        $this->middleware('teamSA', ['except' => ['destroy',] ]);
        $this->middleware('super_admin', ['only' => ['destroy',] ]);

        $this->my_course = $my_course;
        $this->user = $user;
    }

    public function index()
    {
        $d['my_courses'] = $this->my_course->all();


        return view('pages.support_team.courses.index', $d);
    }

    public function store(Request $req)
    {
        $data = $req->all();
        $mc = $this->my_course->create($data);



        return Qs::jsonStoreOk();
    }

    public function edit($id)
    {
        $d['c'] = $c = $this->my_course->find($id);

        return is_null($c) ? Qs::goWithDanger('courses.index') : view('pages.support_team.courses.edit', $d) ;
    }

    public function update(Request $req, $id)
    {
        $data = $req->only(['name']);
        $this->my_course->update($id, $data);

        return Qs::jsonUpdateOk();
    }

    public function destroy($id)
    {
        $this->my_course->delete($id);
        return back()->with('flash_success', __('msg.del_ok'));
    }

}

app/Http/Controllers/SupportTeam/PromotionController.php
<?php

namespace App\Http\Controllers\SupportTeam;

use App\Helpers\Qs;
use App\Http\Controllers\Controller;
use App\Repositories\StudentRepo;
use App\Repositories\PromotionRepo;
use Illuminate\Http\Request;


class PromotionController extends Controller
{
    protected $promotion, $student;

    public function __construct(PromotionRepo $promotion, StudentRepo $student)
    {
        $this->middleware('teamSA');

        $this->promotion = $promotion;
        $this->student = $student;
    }

    public function promotion()
    {
        $d['sessions'] = $this->student->session();
        $d['semester'] = $this->student->semester();
       return view('pages.support_team.students.promotion.index', $d);
    }


    public function getCurrentStudents(Request $req){

        return $this->promotion->getPromotedStudents($req);
    }


    public function getPromotedStudents(Request $req){

        return $this->promotion->getPromotedStudents($req);

    }
    public function addPromotion(Request $req){

       $this->promotion->create($req);
        return Qs::jsonStoreOk();


    }





}

app/Http/Controllers/SupportTeam/SessionController.php
<?php

namespace App\Http\Controllers\SupportTeam;

use App\Helpers\Qs;
use Illuminate\Http\Request;
use App\Repositories\SessionRepo;
use App\Http\Controllers\Controller;
use App\Repositories\UserRepo;

class SessionController extends Controller
{
    protected $my_class, $user;

    public function __construct(SessionRepo $my_class, UserRepo $user)
    {
        $this->middleware('teamSA', ['except' => ['destroy',] ]);
        $this->middleware('super_admin', ['only' => ['destroy',] ]);

        $this->my_class = $my_class;
        $this->user = $user;
    }

    public function index()
    {

        $d['session'] = $this->my_class->all();
        return view('pages.support_team.sessions.index', $d);
    }

    public function store(Request $req)
    {
        $data = $req->all();
        $this->my_class->create($data);

        return Qs::jsonStoreOk();
    }

    public function edit($id)
    {
        $d['s'] = $s = $this->my_class->find($id);


        return is_null($s) ? Qs::goWithDanger('sessions.index') :view('pages.support_team.sessions.edit', $d);
    }

    public function update(Request $req, $id)
    {
        $data = $req->only(['name']);
        $this->my_class->update($id, $data);

        return Qs::jsonUpdateOk();
    }

    public function destroy($id)
    {

        $this->my_class->delete($id);
        return back()->with('flash_success', __('msg.del_ok'));
    }

}

app/Http/Controllers/SupportTeam/StudentRecordController.php
<?php

namespace App\Http\Controllers\SupportTeam;

use App\Helpers\Qs;
use App\Repositories\StudentRepo;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\CustomFields;

use Illuminate\Support\Str;

class StudentRecordController extends Controller
{
    protected $student;

   public function __construct(StudentRepo $student)
   {
       $this->middleware('teamSA', ['only' => ['edit','update', 'reset_pass', 'create', 'store', 'graduated'] ]);
       $this->middleware('super_admin', ['only' => ['destroy',] ]);


        $this->student = $student;
   }

    public function index()
    {

        $data['students']=  $this->student->all();

        return view('pages.support_team.students.list', $data);
    }

    public function create()
    {

        $data['sessions']=$this->student->session();
        $data['courses']=$this->student->courses();
        $data['faculty']=$this->student->Faculty();
        $data['department']=$this->student->Department();
        $data['semester']=$this->student->semester();
        $data['degree']=$this->student->degree();
        $data['fields']=$this->student->fields();


        return view('pages.support_team.students.add', $data);
    }

    public function store(Request $req)
    {

        $this->student->create($req);
        return Qs::jsonStoreOk();
    }


    public function show($sr_id)
    {
        $sr_id = Qs::decodeHash($sr_id);

        if(!$sr_id){return Qs::goWithDanger();}

        $data['student'] = $this->student->getRecordByStudentID($sr_id)['info1'][0];
        $data['student_edu'] = $this->student->getRecordByStudentID($sr_id)['info2'];
        $data['student_additional'] = $this->student->getRecordByStudentID($sr_id)['info3'];
        $data['student_session'] = $this->student->getRecordByStudentID($sr_id)['info4'];



        return view('pages.support_team.students.show', $data);
    }

    public function edit($sr_id)
    {
        $sr_id = Qs::decodeHash($sr_id);

        if(!$sr_id){return Qs::goWithDanger();}

        $data['sessions']=$this->student->session();
        $data['courses']=$this->student->courses();
        $data['faculty']=$this->student->Faculty();
        $data['department']=$this->student->Department();
        $data['semester']=$this->student->semester();
        $data['degree']=$this->student->degree();
        $data['student'] = $this->student->getRecordByStudentID($sr_id)['info1'][0];
        $data['student_edu'] = $this->student->getRecordByStudentID($sr_id)['info2'];
        $data['student_additional'] = $this->student->getRecordByStudentID($sr_id)['info3'];
        $data['student_session'] = $this->student->getRecordByStudentID($sr_id)['info4'];
        $data['fields']=$this->student->fields();

        return view('pages.support_team.students.edit', $data);
    }

    public function update(Request $req, $sr_id)
    {
        $sr_id = Qs::decodeHash($sr_id);
        if(!$sr_id){return Qs::goWithDanger();}

        $this->student->update($sr_id,$req);
        return Qs::jsonStoreOk();


        return Qs::jsonUpdateOk();
    }

    public function destroy($st_id)
    {
        $st_id = Qs::decodeHash($st_id);
        if(!$st_id){return Qs::goWithDanger();}

        $this->student->delete($st_id);

        return back()->with('flash_success', __('msg.del_ok'));
    }


    public function promotion(){

       echo 1;
    }

}

resources/views/pages/support_team/department/edit.blade.php
@extends('layouts.master')
@section('page_title', 'Edit Department')
@section('content')

    <div class="card">
        <div class="card-header header-elements-inline">
            <h6 class="card-title">Edit Department</h6>
            {!! Qs::getPanelOptions() !!}
        </div>

        <div class="card-body">
            <div class="row">
                <div class="col-md-6">
                    <form class="ajax-update" method="post" action="{{ route('department.update', $s->id) }}">
                        @csrf @method('PUT')
                        <div class="form-group row">
                            <label class="col-lg-3 col-form-label font-weight-semibold">Name <span class="text-danger">*</span></label>
                            <div class="col-lg-9">
                                <input name="name" value="{{ $s->name }}" required type="text" class="form-control" placeholder="Name of Subject">
                            </div>
                        </div>




                        <div class="text-right">
                            <button type="submit" class="btn btn-primary">Submit form <i class="icon-paperplane ml-2"></i></button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>

    {{--subject Edit Ends--}}

@endsection

resources/views/pages/support_team/department/index.blade.php
@extends('layouts.master')
@section('page_title', 'Manage department')
@section('content')

    <div class="card">
        <div class="card-header header-elements-inline">
            <h6 class="card-title">Manage department</h6>
            {!! Qs::getPanelOptions() !!}
        </div>

        <div class="card-body">
            <ul class="nav nav-tabs nav-tabs-highlight">
                <li class="nav-item"><a href="#all-classes" class="nav-link active" data-toggle="tab">Manage department</a></li>
                <li class="nav-item"><a href="#new-class" class="nav-link" data-toggle="tab"><i class="icon-plus2"></i> Create New department</a></li>
            </ul>

            <div class="tab-content">
                <div class="tab-pane fade show active" id="all-classes">
                    <table class="table datatable-button-html5-columns">
                        <thead>
                        <tr>
                            <th>S/N</th>
                            <th>Name</th>
                            <th>Action</th>
                        </tr>
                        </thead>
                        <tbody>
                        @foreach($department as $c)
                            <tr>
                                <td>{{ $loop->iteration }}</td>
                                <td>{{ $c->name }}</td>

                                <td class="text-center">
                                    <div class="list-icons">
                                        <div class="dropdown">
                                            <a href="#" class="list-icons-item" data-toggle="dropdown">
                                                <i class="icon-menu9"></i>
                                            </a>

                                            <div class="dropdown-menu dropdown-menu-left">
                                                @if(Qs::userIsTeamSA())
                                                    {{--Edit--}}
                                                    <a href="{{ route('department.edit', $c->id) }}" class="dropdown-item"><i class="icon-pencil"></i> Edit</a>
                                                @endif
                                                @if(Qs::userIsSuperAdmin())
                                                    {{--Delete--}}
                                                    <a id="{{ $c->id }}" onclick="confirmDelete(this.id)" href="#" class="dropdown-item"><i class="icon-trash"></i> Delete</a>
                                                    <form method="post" id="item-delete-{{ $c->id }}" action="{{ route('department.destroy', $c->id) }}" class="hidden">@csrf @method('delete')</form>
                                                @endif

                                            </div>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                        @endforeach
                        </tbody>
                    </table>
                </div>

                <div class="tab-pane fade" id="new-class">

                    <div class="row">
                        <div class="col-md-6">
                            <form class="ajax-store" method="post" action="{{ route('department.store') }}">
                                @csrf
                                <div class="form-group row">
                                    <label class="col-lg-3 col-form-label font-weight-semibold">Name <span class="text-danger">*</span></label>
                                    <div class="col-lg-9">
                                        <input name="name" value="{{ old('name') }}" required type="text" class="form-control" placeholder="Name of department  ">
                                    </div>
                                </div>


                                <div class="text-right">
                                    <button id="ajax-btn" type="submit" class="btn btn-primary">Submit form <i class="icon-paperplane ml-2"></i></button>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    {{--Class List Ends--}}

@endsection